summaryrefslogtreecommitdiffstats
path: root/test/bctest
diff options
context:
space:
mode:
authorBodo Möller <bodo@openssl.org>2001-03-30 09:23:14 +0000
committerBodo Möller <bodo@openssl.org>2001-03-30 09:23:14 +0000
commit83c4e75be945664bf9e47408a19087f66a5b2017 (patch)
tree7a6340d24a78ef5bffb30716d44d9308f0a2d246 /test/bctest
parente5f3be2bbb8c7e5b7c29bfcb99004572e9f383af (diff)
Use enhanced bctest (as in main trunk), and add a workaround that
should solve the problems with FreeBSD's /bin/sh.
Diffstat (limited to 'test/bctest')
-rwxr-xr-xtest/bctest61
1 files changed, 38 insertions, 23 deletions
diff --git a/test/bctest b/test/bctest
index 6fa0663bb0..b9ef95bf82 100755
--- a/test/bctest
+++ b/test/bctest
@@ -11,8 +11,9 @@
# running) bc.
-# Test for SunOS 5.[78] bc bug (or missing bc)
-if [ 0 != "`bc <<\EOF
+# Test for SunOS 5.[78] bc bug
+SunOStest() {
+${1} >tmp.bctest <<\EOF
obase=16
ibase=16
a=AD88C418F31B3FC712D0425001D522B3AE9134FF3A98C13C1FCC1682211195406C1A6C66C6A\
@@ -26,17 +27,18 @@ b=DCE91E7D120B983EA9A104B5A96D634DD644C37657B1C7860B45E6838999B3DCE5A555583C6\
8B3CD64126E1A82E190228020C05B91C8B141F1110086FC2A4C6ED631EBA129D04BB9A19FC53D\
3ED0E2017D60A68775B75481449
(a/b)*b + (a%b) - a
-EOF`" ]
+EOF
+if [ 0 != "`cat tmp.bctest`" ]
then
- echo "bc does not work. Consider installing GNU bc." >&2
- echo "cat >/dev/null"
- exit 1
+ # failure
+ return 1
fi
+}
# Test for SCO bc bug.
-if [ "0
-0" != "`bc <<\EOF
+SCOtest() {
+${1} >tmp.bctest <<\EOF
obase=16
ibase=16
-FFDD63BA1A4648F0D804F8A1C66C53F0D2110590E8A3907EC73B4AEC6F15AC177F176F2274D2\
@@ -62,23 +64,36 @@ F617E3145BBFBE9AFD0D6E437EA4FF6F04BC67C4F1458B4F0F47B64 - 1C2BBBB19B74E86FD32\
9E8DB6A8C3B1B9986D57ED5419C2E855F7D5469E35E76334BB42F4C43E3F3A31B9697C171DAC4\
D97935A7E1A14AD209D6CF811F55C6DB83AA9E6DFECFCD6669DED7171EE22A40C6181615CAF3F\
5296964
-EOF`" ]
+EOF
+if [ "0
+0" != "`cat tmp.bctest`" ]
then
- echo "bc does not work. Consider installing GNU bc." >&2
- echo "cat >/dev/null"
- exit 1
+ # failure
+ return 1
fi
+}
-# bc works, good.
-# Now check if it knows the 'print' command.
-if [ "OK" = "`bc 2>/dev/null <<\EOF
-print \"OK\"
-EOF`" ]
-then
- echo "bc"
-else
- echo "sed 's/print.*//' | bc"
-fi
+IFS=:
+for dir in $PATH; do
+ bc="$dir/bc"
+
+ if [ -x "$bc" -a ! -d "$bc" ]; then
+ if SunOStest "$bc" && SCOtest "$bc"; then
+ # bc works; now check if it knows the 'print' command.
+ if [ "OK" = "`echo 'print \"OK\"' | $bc 2>/dev/null`" ]
+ then
+ echo "$bc"
+ else
+ echo "sed 's/print.*//' | $bc"
+ fi
+ exit 0
+ fi
+
+ echo "$bc does not work properly. Looking for another bc ..." >&2
+ fi
+done
-exit 0
+echo "No working bc found. Consider installing GNU bc." >&2
+echo "cat >/dev/null"
+exit 1